package tools.descartes.dql.connector.kieker.structures.cpu;



import tools.descartes.dql.connector.kieker.structures.AbstractCollectorMap;
import tools.descartes.dql.connector.kieker.structures.ResourceContent;
import tools.descartes.dql.connector.kieker.structures.Trace;
import tools.descartes.dql.connector.kieker.structures.identifier.ResourceIdentifier;
import tools.descartes.dql.connector.kieker.structures.records.ResourceRecord;



/**
 * 
 * @author Jack
 *
 */
public class CpuMap extends AbstractCollectorMap<CpuMapKey,CpuMapValue>{

	private static final long serialVersionUID = 6378079838732308381L;
	private static CpuMap instance;


	private CpuMap(){};

	/**
	 * 
	 * @return Singleton instance
	 */
	public static synchronized CpuMap getInstance () {
		if (CpuMap.instance == null) {
			CpuMap.instance = new CpuMap();
		}
		return CpuMap.instance;
	}


	@Override
	protected Object isUpdateValue(Object key, Object newValue) {
		CpuMapValue newCpuValue = null;
		if (newValue instanceof CpuMapValue) {
			newCpuValue = (CpuMapValue) newValue;
			CpuMapValue oldValue = (CpuMapValue) get(key);
			long timestamp = newCpuValue.getCurrentTimestamp();
			ResourceContent cpuValues = newCpuValue.getCurrentData();
			CpuMapValue enhancedValue = oldValue.enhance(timestamp,cpuValues);
			return enhancedValue;
		} 
		return null;
	}


	@Override
	public void pushToTrace(Trace trace) {
		for (Entry<CpuMapKey, CpuMapValue> entry : CpuMap.getInstance().entrySet()) {
			
			String hostName =entry.getKey().getHostname();
			String keyID = entry.getKey().getStringItems();
			long timestamp = entry.getValue().getCurrentTimestamp();
			ResourceContent entities = entry.getValue().getCurrentData();
			trace.addResource(new ResourceRecord(ResourceIdentifier.createResourceIdentifier(hostName,keyID), timestamp, entities));
		}
	}

}
